package com.example.testandroid;

import java.io.File;
import java.io.FileNotFoundException;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

import android.os.Environment;
import android.os.storage.StorageManager;
import android.util.Log;

/**
 * ⲿ洢豸ࡣ
 * 
 * @author 
 * */
public class ExternalStorage {

	/**
	 * sd
	 * */
	public static final String SD_CARD = "sdCard";

	/**
	 * sd
	 * */
	public static final String EXTERNAL_SD_CARD = "externalSdCard";

	/**
	 * sdǷжأжûsd
	 * */
	public static boolean isRemovable() {

		return Environment.isExternalStorageRemovable();

	}

	/**
	 * @return True ⲿ洢. False .
	 */
	public static boolean isAvailable() {
		String state = Environment.getExternalStorageState();
		if (Environment.MEDIA_MOUNTED.equals(state)
				|| Environment.MEDIA_MOUNTED_READ_ONLY.equals(state)) {
			return true;
		}
		return false;
	}

	public static String getSdCardPath() {
		return Environment.getExternalStorageDirectory().getPath() + "/";
	}

	/**
	 * @return True :ɶд. False ɶд.
	 */
	public static boolean isWritable() {
		String state = Environment.getExternalStorageState();
		if (Environment.MEDIA_MOUNTED.equals(state)) {
			return true;
		}
		return false;

	}

	/**
	 * @return ⲿ洢mapϣúsd
	 */
	public static Map<String, File> getAllStorageLocations() {
		Map<String, File> map = new HashMap<String, File>(10);

		List<String> mMounts = new ArrayList<String>(10);
		List<String> mVold = new ArrayList<String>(10);

		String localSD = Environment.getExternalStorageDirectory().getPath();

		mMounts.add(localSD);
		mVold.add(localSD);

		try {
			File mountFile = new File("/proc/mounts");
			if (mountFile.exists()) {
				Scanner scanner = new Scanner(mountFile);
				while (scanner.hasNext()) {
					String line = scanner.nextLine();
					if (line.startsWith("/dev/block/vold/")) {
						String[] lineElements = line.split(" ");
						String element = lineElements[1];

						// don't add the default mount path
						// it's already in the list.
						if (!element.equals(localSD))
							mMounts.add(element);
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		Log.i("sd2", "mMounts==" + mMounts.toString());

		Scanner scanner = null;
		try {
			File voldFile = new File("/system/etc/vold.fstab");
			if (voldFile.exists()) {
				scanner = new Scanner(voldFile);
				while (scanner.hasNext()) {
					String line = scanner.nextLine();
					if (line.startsWith("dev_mount")) {
						String[] lineElements = line.split(" ");
						String element = lineElements[2];

						if (element.contains(":"))
							element = element
									.substring(0, element.indexOf(":"));
						if (!element.equals(localSD))
							mVold.add(element);
					}
				}
			}
		} catch (ArrayIndexOutOfBoundsException e) {//пlinetable"	"ָġ

			while (scanner.hasNext()) {
				String line = scanner.nextLine();
				if (line.startsWith("dev_mount")) {
					String[] lineElements = line.split("	");
					String element = lineElements[2];

					if (element.contains(":"))
						element = element.substring(0, element.indexOf(":"));
					if (!element.equals(localSD))
						mVold.add(element);
				}
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

		Log.i("sd2", "mVold==" + mVold.toString());

		for (int i = 0; i < mMounts.size(); i++) {
			String mount = mMounts.get(i);
			// if (!mVold.contains(mount))
			// mMounts.remove(i--);

			if (!new File(mount + "/"
					+ XyConstant.FileConstant.ROOT_FOLDER_NAME + "/").exists()) {

				if (!mount.equals(localSD)) {

					mMounts.remove(i--);

				}

			}

		}
		mVold.clear();

		List<String> mountHash = new ArrayList<String>(10);

		for (String mount : mMounts) {
			File root = new File(mount);

			if (root.exists() && root.isDirectory()) {

				root.setWritable(true);

				File[] list = root.listFiles();
				String hash = "[";
				if (list != null) {
					for (File f : list) {
						hash += f.getName().hashCode() + ":" + f.length()
								+ ", ";
					}
				}
				hash += "]";
				if (!mountHash.contains(hash)) {
					String key = SD_CARD + "_" + map.size();
					if (map.size() == 0) {
						key = SD_CARD;
					} else if (map.size() == 1) {
						key = EXTERNAL_SD_CARD;
					}
					mountHash.add(hash);
					map.put(key, root);
				}
			}
		}

		mMounts.clear();

		if (map.isEmpty()) {
			map.put(SD_CARD, Environment.getExternalStorageDirectory());
		}
		return map;
	}
}
