package com.example.testandroid;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Map;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Environment;
import android.os.Handler;
import android.os.StatFs;

public class SdCardStorage {
	public static final String SHARED_STR_STORAGE = "storage";
	public static final String SHARED_STR_STORAGE_DB_INITIAL = "storageDBInitiall";
	public static final String SHARED_STR_STORAGE_INITIAL = "storageFileInitiall";
	public static final String NAME_DIRECTORY1 = "xueyi";
	public static final String NAME_DIRECTORY2 = "com.zxxk.com";

	private Context ctx;
	private Handler handler;
	private String storagePath;
	private SharedPreferences sp;

	public SdCardStorage(Context ctx, Handler handler) {
		this.handler = handler;
		this.ctx = ctx;
		sp = ctx.getSharedPreferences(SHARED_STR_STORAGE, 0);
	}

	private static boolean ExistSDCard() {
		if (android.os.Environment.getExternalStorageState().equals(
				android.os.Environment.MEDIA_MOUNTED)) {
			return true;
		} else
			return false;
	}

	public static long getAvailableStore(String filePath) {
		// ȡsdcardļ·
		StatFs statFs = new StatFs(filePath);
		// ȡblockSIZE
		long blocSize = statFs.getBlockSize();
		// ȡBLOCK
		long totalBlocks = statFs.getBlockCount();
		// ʹõBlock
		long availaBlock = statFs.getAvailableBlocks();

		long total = totalBlocks * blocSize;

		long availableSpare = availaBlock * blocSize;

		return availableSpare;

	}

	public static long getFolderSize(String filePath) throws Exception {
		long size = 0;
		java.io.File file = new File(filePath);
		if (!file.exists()) {
			return 0;
		}
		java.io.File[] fileList = file.listFiles();
		for (int i = 0; i < fileList.length; i++) {
			if (fileList[i].isDirectory()) {
				size = size + getFolderSize(fileList[i].getPath());
			} else

			{
				size = size + fileList[i].length();
			}
		}
		return size;
	}

	static public boolean resetStoragePath(boolean isMounted) {
		if (isMounted) {
			// sdcard
		} else {
			// if (!ExistSDCard()) {// sdcard
			// return;
			// }else{
			// MyConstant.FileConstant.ROOT_FILL_PATH =
			// Environment.getExternalStorageDirectory()+"";
			// }
			Map<String, File> externalLocations = ExternalStorage
					.getAllStorageLocations();
			final File sdCard = externalLocations.get(ExternalStorage.SD_CARD);

			boolean isRemove = ExternalStorage.isRemovable();
			
			if (isRemove) {
				
				return true;
				
			}else{
				
				if (sdCard != null
						&& sdCard.getPath().equals(
								XyConstant.FileConstant.ROOT_FILL_PATH)) {
					return true;
					
				} else {
					return true;
				}
				
				
			}


		}
		return false;
	}

	/**
	 * ļм
	 * 
	 * @param file1
	 * @param file2
	 * @return
	 */

	public static void delete(File file) {
		if (file.isFile()) {
			file.delete();
			return;
		}

		if (file.isDirectory()) {
			File[] childFiles = file.listFiles();
			if (childFiles == null || childFiles.length == 0) {
				file.delete();
				return;
			}

			for (int i = 0; i < childFiles.length; i++) {
				delete(childFiles[i]);
			}
			file.delete();
		}
	}

}
